


//************************************************
//*** Define宣言
#define LED_GREEN			27
#define LED_ORANGE			22
#define LED_RED				25

#define OFF					0
#define ON					1

#define SW_SHUTDOWN			24
#define SW_RECORD			23
#define SW_CANCEL			18

#define SET_TIME_COUNT_MAX	(10)									// 時間設定構造体の設定上限数
#define CMD_LENGTH			(256)									// グループ名、コマンドの文字列長
#define HEADER_SIZE			(1 + 1 + 1 + CMD_LENGTH + CMD_LENGTH)	// set_time_struct構造体のサイズ(実サイズではなく、通信仕様上のサイズ)

#define false				0
#define true				1

#define FILE_NAME_GET_CMD_NAME	"get_cmd_name.pl"



//************************************************
//*** 関数のプロトタイプ宣言
void	signal_callback_handler(int);
void	interrupt_signal_alarm_handler(int);
void	interrupt_key_cancel_handler(void);
void	interrupt_key_record_handler(void);
void	timer_end_judge();
void	get_cur_time(uint32_t *);
void	set_start_state();
void	set_idle_state();
void	send_ir_data();
void	send_response(uint8_t);
int		data_receive(int, char *, int);
int		bluetooth_receive();
void	get_mypathname(char *);
void	shutdown_process();



//************************************************
//*** 列挙体の宣言
// ステート
typedef enum  {
	STATE_IDLE,					// IDLE
	STATE_START_COUNTDOWN,		// 動作開始 : カウントダウンモードで実行中
	STATE_START_TIMER,			// 動作開始 : タイマーモードで実行中
	STATE_ERROR					// エラー
} STATE;

// タイマー種類
typedef enum  {
	KIND_COUNTDOWN,				// スマホから設定されたカウントダウン値を表示
	KIND_TIMER					// スマホから設定された設定時刻を表示
} TIMER_KIND;

// 実行終了後
typedef enum  {
	CAS_KEEP,					// 実行終了後もそのまま
	CAS_SHUTDOWN				// 実行が終わったらシャットダウンする
} COMPLETE_AFTER_SHUTDOWN_KIND;



//************************************************
//*** 構造体宣言
// タイマー設定保持用
typedef struct {
    TIMER_KIND kind;					// タイマーの種類
    unsigned int	hh;					// 設定時刻hh
    unsigned int	mm;					// 設定時刻mm

    char			group[CMD_LENGTH];	// グループ名
    char			cmd[CMD_LENGTH];	// コマンド名
} set_time_struct;						// タグ名



